#include <sourcemod>
#include <sdktools>

new players[MAXPLAYERS+1], kills[MAXPLAYERS+1], bounties[MAXPLAYERS+1], customs[MAXPLAYERS+1];
new PlCount;
new PlCash = -1;
new Handle:MB_Enabled_CVar;
new Handle:MB_HelpAdvert_CVar;
new Handle:MB_KillsStart_CVar;
new Handle:MB_StartBounty_CVar;
new Handle:MB_KillBonus_CVar;
new Handle:MB_RoundBonus_CVar;
new Handle:MB_HeadBonus_CVar;
new Handle:MB_GrenBonus_CVar;
new Handle:MB_KnifeBonus_CVar;
new Handle:MB_CTRed_CVar;
new Handle:MB_CTGreen_CVar;
new Handle:MB_CTBlue_CVar;
new Handle:MB_CTAlpha_CVar;
new Handle:MB_TRed_CVar;
new Handle:MB_TGreen_CVar;
new Handle:MB_TBlue_CVar;
new Handle:MB_TAlpha_CVar;
new bool:MB_Enabled;
new bool:MB_HelpAdvert;
new MB_KillsStart, MB_StartBounty, MB_KillBonus, MB_RoundBonus, MB_HeadBonus, MB_GrenBonus, MB_KnifeBonus, MB_CTRed, MB_CTGreen, MB_CTBlue, MB_CTAlpha, MB_TRed, MB_TGreen, MB_TBlue, MB_TAlpha;
new String:Top3BountiesStr[1500];


public Plugin:myinfo = 
{
	name = "Mani Bounty Clone++",
	author = "c-h-i-z-h",
	description = "Clone of mani_bounty function.",
	version = "1.6",
	url = "http://chizh.servegame.com"
}

public OnPluginStart()
{
	LoadTranslations("ma_bounty.phrases");
	PlCash = FindSendPropOffs("CCSPlayer", "m_iAccount");
	
	MB_Enabled_CVar = CreateConVar("sm_ma_bounty_enabled", "1", "Enable or Disable Bounties.");
	MB_HelpAdvert_CVar = CreateConVar("sm_ma_bounty_helpadv", "1", "Enable or Disable help adverts.");
	MB_KillsStart_CVar = CreateConVar("sm_ma_bounty_killsstart", "5", "Kills reqired to start bounty.");
	MB_StartBounty_CVar = CreateConVar("sm_ma_bounty_startbounty", "1000", "Start bounty cash.");
	MB_KillBonus_CVar = CreateConVar("sm_ma_bounty_killbonus", "250", "Bonus for kill.");
	MB_RoundBonus_CVar = CreateConVar("sm_ma_bounty_roundbonus", "500", "Bonus for round alive.");
	MB_HeadBonus_CVar = CreateConVar("sm_ma_bounty_headbonus", "20", "Percent bonus for HeadShot 0-100.");
	MB_GrenBonus_CVar = CreateConVar("sm_ma_bounty_grenbonus", "50", "Percent bonus for Grenade kill 0-100.");
	MB_KnifeBonus_CVar = CreateConVar("sm_ma_bounty_knifebonus", "100", "Percent bonus for Knife kill 0-100.");
	MB_CTRed_CVar = CreateConVar("sm_ma_bounty_ctred", "50", "CT Red color 0-255.");
	MB_CTGreen_CVar = CreateConVar("sm_ma_bounty_ctgreen", "150", "CT Green color 0-255.");
	MB_CTBlue_CVar = CreateConVar("sm_ma_bounty_ctblue", "255", "CT Blue color 0-255.");
	MB_CTAlpha_CVar = CreateConVar("sm_ma_bounty_ctalpha", "200", "CT Opacity 0-255.");
	MB_TRed_CVar = CreateConVar("sm_ma_bounty_tred", "255", "T Red color 0-255.");
	MB_TGreen_CVar = CreateConVar("sm_ma_bounty_tgreen", "50", "T Green color 0-255.");
	MB_TBlue_CVar = CreateConVar("sm_ma_bounty_tblue", "150", "T Blue color 0-255.");
	MB_TAlpha_CVar = CreateConVar("sm_ma_bounty_talpha", "200", "T Opacity 0-255.");
	
	HookConVarChange(MB_Enabled_CVar,ConVarChanged);
	HookConVarChange(MB_HelpAdvert_CVar,ConVarChanged);
	HookConVarChange(MB_KillsStart_CVar,ConVarChanged);
	HookConVarChange(MB_StartBounty_CVar,ConVarChanged);
	HookConVarChange(MB_KillBonus_CVar,ConVarChanged);
	HookConVarChange(MB_RoundBonus_CVar,ConVarChanged);
	HookConVarChange(MB_HeadBonus_CVar,ConVarChanged);
	HookConVarChange(MB_GrenBonus_CVar,ConVarChanged);
	HookConVarChange(MB_KnifeBonus_CVar,ConVarChanged);
	HookConVarChange(MB_CTRed_CVar,ConVarChanged);
	HookConVarChange(MB_CTGreen_CVar,ConVarChanged);
	HookConVarChange(MB_CTBlue_CVar,ConVarChanged);
	HookConVarChange(MB_CTAlpha_CVar,ConVarChanged);
	HookConVarChange(MB_TRed_CVar,ConVarChanged);
	HookConVarChange(MB_TGreen_CVar,ConVarChanged);
	HookConVarChange(MB_TBlue_CVar,ConVarChanged);
	HookConVarChange(MB_TAlpha_CVar,ConVarChanged);

	HookEvent("player_activate", EventPlActivate);
	HookEvent("player_disconnect", EventPlDisconnect);
	HookEvent("player_death", EventPlDeath);
	HookEvent("round_start", EventRoundStart);

	RegConsoleCmd("say", Command_Say);

	AutoExecConfig(true, "ma_bounty");
}

public OnConfigsExecuted()
{
   	MB_Enabled = GetConVarBool(MB_Enabled_CVar);
   	MB_HelpAdvert = GetConVarBool(MB_HelpAdvert_CVar);
	MB_KillsStart = GetConVarInt(MB_KillsStart_CVar);
	MB_StartBounty = GetConVarInt(MB_StartBounty_CVar);
	MB_KillBonus = GetConVarInt(MB_KillBonus_CVar);
	MB_RoundBonus = GetConVarInt(MB_RoundBonus_CVar);
	MB_HeadBonus = GetConVarInt(MB_HeadBonus_CVar);
	if (MB_HeadBonus > 100)
		MB_HeadBonus = 100;
	if (MB_HeadBonus < 0)
		MB_HeadBonus = 0;
	MB_GrenBonus = GetConVarInt(MB_GrenBonus_CVar);
	if (MB_GrenBonus > 100)
		MB_GrenBonus = 100;
	if (MB_GrenBonus < 0)
		MB_GrenBonus = 0;
	MB_KnifeBonus = GetConVarInt(MB_KnifeBonus_CVar);
	if (MB_KnifeBonus > 100)
		MB_KnifeBonus = 100;
	if (MB_KnifeBonus < 0)
		MB_KnifeBonus = 0;
	MB_CTRed = GetConVarInt(MB_CTRed_CVar);
	if (MB_CTRed > 255)
		MB_CTRed = 255;
	if (MB_CTRed < 0)
		MB_CTRed = 0;
	MB_CTGreen = GetConVarInt(MB_CTGreen_CVar);
	if (MB_CTGreen > 255)
		MB_CTGreen = 255;
	if (MB_CTGreen < 0)
		MB_CTGreen = 0;
	MB_CTBlue = GetConVarInt(MB_CTBlue_CVar);
	if (MB_CTBlue > 255)
		MB_CTBlue = 255;
	if (MB_CTBlue < 0)
		MB_CTBlue = 0;
	MB_CTAlpha = GetConVarInt(MB_CTAlpha_CVar);
	if (MB_CTAlpha > 255)
		MB_CTAlpha = 255;
	if (MB_CTAlpha < 0)
		MB_CTAlpha = 0;
	MB_TRed = GetConVarInt(MB_TRed_CVar);
	if (MB_TRed > 255)
		MB_TRed = 255;
	if (MB_TRed < 0)
		MB_TRed = 0;
	MB_TGreen = GetConVarInt(MB_TGreen_CVar);
	if (MB_TGreen > 255)
		MB_TGreen = 255;
	if (MB_TGreen < 0)
		MB_TGreen = 0;
	MB_TBlue = GetConVarInt(MB_TBlue_CVar);
	if (MB_TBlue > 255)
		MB_TBlue = 255;
	if (MB_TBlue < 0)
		MB_TBlue = 0;
	MB_TAlpha = GetConVarInt(MB_TAlpha_CVar);
	if (MB_TAlpha > 255)
		MB_TAlpha = 255;
	if (MB_TAlpha < 0)
		MB_TAlpha = 0;
}

public ConVarChanged(Handle:convar, const String:oldValue[], const String:newValue[])
{
	if(convar == MB_HelpAdvert_CVar)
    	MB_HelpAdvert = GetConVarBool(MB_HelpAdvert_CVar);
	if(convar == MB_Enabled_CVar)
    	MB_Enabled = GetConVarBool(MB_Enabled_CVar);
	if(convar == MB_KillsStart_CVar)
    	MB_KillsStart = GetConVarInt(MB_KillsStart_CVar);
	if(convar == MB_StartBounty_CVar)
    	MB_StartBounty = GetConVarInt(MB_StartBounty_CVar);
	if(convar == MB_KillBonus_CVar)
    	MB_KillBonus = GetConVarInt(MB_KillBonus_CVar);
	if(convar == MB_RoundBonus_CVar)
    	MB_RoundBonus = GetConVarInt(MB_RoundBonus_CVar);
	if(convar == MB_HeadBonus_CVar)
	{
		MB_HeadBonus = GetConVarInt(MB_HeadBonus_CVar);
		if (MB_HeadBonus > 100)
			MB_HeadBonus = 100;
		if (MB_HeadBonus < 0)
			MB_HeadBonus = 0;
	}
	if(convar == MB_GrenBonus_CVar)
	{
		MB_GrenBonus = GetConVarInt(MB_GrenBonus_CVar);
		if (MB_GrenBonus > 100)
			MB_GrenBonus = 100;
		if (MB_GrenBonus < 0)
			MB_GrenBonus = 0;
	}
	if(convar == MB_KnifeBonus_CVar)
	{
		MB_KnifeBonus = GetConVarInt(MB_KnifeBonus_CVar);
		if (MB_KnifeBonus > 100)
			MB_KnifeBonus = 100;
		if (MB_KnifeBonus < 0)
			MB_KnifeBonus = 0;
	}
	if(convar == MB_CTRed_CVar)
	{
		MB_CTRed = GetConVarInt(MB_CTRed_CVar);
		if (MB_CTRed > 255)
			MB_CTRed = 255;
		if (MB_CTRed < 0)
			MB_CTRed = 0;
	}
	if(convar == MB_CTGreen_CVar)
	{
		MB_CTGreen = GetConVarInt(MB_CTGreen_CVar);
		if (MB_CTGreen > 255)
			MB_CTGreen = 255;
		if (MB_CTGreen < 0)
			MB_CTGreen = 0;
	}
	if(convar == MB_CTBlue_CVar)
	{
		MB_CTBlue = GetConVarInt(MB_CTBlue_CVar);
		if (MB_CTBlue > 255)
			MB_CTBlue = 255;
		if (MB_CTBlue < 0)
			MB_CTBlue = 0;
	}
	if(convar == MB_CTAlpha_CVar)
	{
		MB_CTAlpha = GetConVarInt(MB_CTAlpha_CVar);
		if (MB_CTAlpha > 255)
			MB_CTAlpha = 255;
		if (MB_CTAlpha < 0)
			MB_CTAlpha = 0;
	}
	if(convar == MB_TRed_CVar)
	{
		MB_TRed = GetConVarInt(MB_TRed_CVar);
		if (MB_TRed > 255)
			MB_TRed = 255;
		if (MB_TRed < 0)
			MB_TRed = 0;
	}
	if(convar == MB_TGreen_CVar)
	{
		MB_TGreen = GetConVarInt(MB_TGreen_CVar);
		if (MB_TGreen > 255)
			MB_TGreen = 255;
		if (MB_TGreen < 0)
			MB_TGreen = 0;
	}
	if(convar == MB_TBlue_CVar)
	{
		MB_TBlue = GetConVarInt(MB_TBlue_CVar);
		if (MB_TBlue > 255)
			MB_TBlue = 255;
		if (MB_TBlue < 0)
			MB_TBlue = 0;
	}
	if(convar == MB_TAlpha_CVar)
	{
		MB_TAlpha = GetConVarInt(MB_TAlpha_CVar);
		if (MB_TAlpha > 255)
			MB_TAlpha = 255;
		if (MB_TAlpha < 0)
			MB_TAlpha = 0;
	}
}

public EventPlActivate(Handle:event,const String:name[],bool:dontBroadcast)
{
	if (MB_Enabled)
	{
		new PlayerId = GetEventInt(event,"userid");
		new bool:PlayerExist = false;
		for (new i=0; i<PlCount; i++)
		{
			if (PlayerId == players[i])
			{
				PlayerExist = true;
			}
		}
		if (!PlayerExist)
		{
			players[PlCount] = PlayerId;
			kills[PlCount] = 0;
			bounties[PlCount] = 0;
			customs[PlCount] = 0;
			PlCount++;
		}
	}
}

public EventPlDisconnect(Handle:event,const String:name[],bool:dontBroadcast)
{
	if (MB_Enabled)
	{
		new PlIndex = -1;
		new PlayerId = GetEventInt(event,"userid");
		for (new i=0; i<PlCount; i++)
		{
			if (PlayerId == players[i])
				PlIndex = i;
		}
		if (PlIndex >= 0)
		{
			PlCount--;
			if (PlIndex < PlCount)
			{
				players[PlIndex] = players[PlCount];
				kills[PlIndex] = kills[PlCount];
				bounties[PlIndex] = bounties[PlCount];
				customs[PlIndex] = customs[PlCount];
			}
			for (new i=PlCount; i<MAXPLAYERS; i++)
			{
				players[i] = 0;
				kills[i] = 0;
				bounties[i] = 0;
				customs[i] = 0;
			}
		}
	}
}

public OnMapStart()
{
	PlCount = 0;
	for (new i=0; i<MAXPLAYERS; i++)
	{
		players[i] = 0;
		kills[i] = 0;
		bounties[i] = 0;
		customs[i] = 0;
	}
}

public EventPlDeath(Handle:event,const String:name[],bool:dontBroadcast)
{
	if (MB_Enabled)
	{
		new victim = GetEventInt(event, "userid");
		new attacker = GetEventInt(event, "attacker");
		new VictimIndex,  AttackerIndex, VictimTeam, AttackerTeam, HeadBonus, GrenBonus, KnifeBonus, ExtBonus;
		new String:dominator[255]; 
		new String:killer[255]; 
		new String:dominator_cl[265]; 
		new String:killer_cl[265]; 
		new String:bounty_cl[20];
		new String:Weapon[100];
		new bool:HeadShot = GetEventBool(event, "headshot");
		GetEventString(event, "weapon", Weapon, sizeof(Weapon));
		VictimTeam = GetClientTeam(GetClientOfUserId(victim));
		if (attacker == 0)
		{
			AttackerTeam = 0
		} else {
			AttackerTeam = GetClientTeam(GetClientOfUserId(attacker));
		}
		
		if (HeadShot)
			{
				HeadBonus = 100 + MB_HeadBonus;
			} else {
				HeadBonus = 100;
			}
		if (strcmp(Weapon, "hegrenade", false) == 0)
			{
				GrenBonus = 100 + MB_GrenBonus;
			} else {
				GrenBonus = 100;
			}
		if (strcmp(Weapon, "knife", false) == 0)
			{
				KnifeBonus = 100 + MB_KnifeBonus;
			} else {
				KnifeBonus = 100;
			}
		ExtBonus = (HeadBonus * GrenBonus * KnifeBonus)/10000;
		
		for (new i=0; i<PlCount; i++)
		{
			if (victim == players[i])
				VictimIndex = i;
			if (attacker == players[i])
				AttackerIndex = i;
		}
		
		if (VictimTeam == AttackerTeam)
		{
			if (victim == attacker)
			{
				kills[VictimIndex] = 0;
				if (bounties[VictimIndex] > 0)
				{
					GetClientName(GetClientOfUserId(players[VictimIndex]), dominator,sizeof(dominator));
					Format(dominator_cl, sizeof(dominator_cl), "\x04%s\x03", dominator);
					Format(bounty_cl, sizeof(bounty_cl), "\x04%d$\x03", bounties[VictimIndex]);
					PrintToChatAll("\x03%t","bounty_lose", bounty_cl, dominator_cl);	
					bounties[VictimIndex] = 0;
				}
			}
		} else {
			kills[AttackerIndex]++;
			kills[VictimIndex] = 0;
		}
		
		if (kills[AttackerIndex] == MB_KillsStart)
		{
			bounties[AttackerIndex] = bounties[AttackerIndex] + MB_StartBounty;
			
			GetClientName(GetClientOfUserId(players[AttackerIndex]),dominator,sizeof(dominator));
			Format(dominator_cl, sizeof(dominator_cl), "\x04%s\x03",dominator);
			Format(bounty_cl, sizeof(bounty_cl), "\x04%d$\x03",bounties[AttackerIndex]);
			PrintToChatAll("\x03%t","bounty_start", dominator_cl, bounty_cl);	
			
			if (MB_HelpAdvert)
				CreateTimer(5.0, ShowAdverts);
			
			SetEntityRenderMode(GetClientOfUserId(players[AttackerIndex]), RENDER_TRANSCOLOR);
			if (AttackerTeam == 2)
				SetEntityRenderColor(GetClientOfUserId(players[AttackerIndex]), MB_TRed, MB_TGreen, MB_TBlue, MB_TAlpha);
			if (AttackerTeam == 3)
				SetEntityRenderColor(GetClientOfUserId(players[AttackerIndex]), MB_CTRed, MB_CTGreen, MB_CTBlue, MB_CTAlpha);
		}
		if (kills[AttackerIndex] > MB_KillsStart)
			bounties[AttackerIndex] = bounties[AttackerIndex] + (MB_KillBonus * ExtBonus)/100;
			
		if (bounties[VictimIndex] > 0 && VictimTeam != AttackerTeam)
		{
			new EndBounty = (bounties[VictimIndex] * ExtBonus)/100;
			GetClientName(GetClientOfUserId(players[AttackerIndex]), killer,sizeof(killer));
			GetClientName(GetClientOfUserId(players[VictimIndex]), dominator,sizeof(dominator));
			Format(killer_cl, sizeof(killer_cl), "\x04%s\x03", killer);
			Format(dominator_cl, sizeof(dominator_cl), "\x04%s\x03", dominator);
			Format(bounty_cl, sizeof(bounty_cl), "\x04%d$\x03", EndBounty);
			PrintToChatAll("\x03%t","bounty_earned", killer_cl, bounty_cl, dominator_cl);
			
			if (PlCash != -1)
			{
				new Rewarder = GetClientOfUserId(players[AttackerIndex]);
				new RewarderCash = GetEntData(Rewarder, PlCash) + EndBounty;
				if (RewarderCash > 16000)
				{
					SetEntData(Rewarder, PlCash, 16000, _, true);
				} else {
					SetEntData(Rewarder, PlCash, RewarderCash, _, true);
				}
				bounties[VictimIndex] = 0;
			}
		}
	}
	
}

public EventRoundStart(Handle:event,const String:name[],bool:dontBroadcast)
{
	if (MB_Enabled)
	{
		for (new i=0; i<PlCount; i++)
		{
			if (bounties[i] > 0)
			{
				SetEntityRenderMode(GetClientOfUserId(players[i]), RENDER_TRANSCOLOR);
				new DominatorTeam = GetClientTeam(GetClientOfUserId(players[i]));
				if (DominatorTeam == 2)
					SetEntityRenderColor(GetClientOfUserId(players[i]), MB_TRed, MB_TGreen, MB_TBlue, MB_TAlpha);
				if (DominatorTeam == 3)
					SetEntityRenderColor(GetClientOfUserId(players[i]), MB_CTRed, MB_CTGreen, MB_CTBlue, MB_CTAlpha);
				bounties[i] = bounties[i] + MB_RoundBonus;
			}
		}
	}
}

public TopPlayerBounty()
{
	new playerbuf, bountybuf, killsbuf;
	new bool:UnSorted = true;
	new String:BountyStr[270];
	new String:ClName[255];
	while (UnSorted)
	{
		UnSorted = false;
		for (new i=1; i<PlCount; i++)
		{
			if (bounties[i] > bounties[i-1])
			{
				bountybuf = bounties[i-1];
				bounties[i-1] = bounties[i];
				bounties[i] = bountybuf;
				playerbuf = players[i-1];
				players[i-1] = players[i];
				players[i] = playerbuf;
				killsbuf = kills[i-1];
				kills[i-1] = kills[i];
				kills[i] = killsbuf;
				UnSorted = true;
			}
		}
	}
	
	Top3BountiesStr = "";
	for (new i=0; i<3; i++)
	{
		if (players[i] > 0 && bounties[i] > 0)
		{
			GetClientName(GetClientOfUserId(players[i]),ClName,sizeof(ClName));
			Format(BountyStr, sizeof(BountyStr), "  %s  -  %d$ \n", ClName, bounties[i]);
			Format(Top3BountiesStr, sizeof(Top3BountiesStr), "%s%s", Top3BountiesStr, BountyStr);
		}
	}
}

public Action:ShowAdverts(Handle:timer)
{
	new String:BountyCl[20];
	Format(BountyCl, sizeof(BountyCl), "\x04bounty\x01");
	PrintToChatAll("\x04[SM Ma Bounty] \x01%t", "help_advert", BountyCl);
}

public Action:Command_Say(client, args)
{
	if (!client)
	{
		return Plugin_Continue;
	}
	
	new String:ChatText[192];
	if (!GetCmdArgString(ChatText, sizeof(ChatText)))
	{
		return Plugin_Continue;
	}
	new StartInd = 0;
	if(ChatText[strlen(ChatText)-1] == '"')
	{
		ChatText[strlen(ChatText)-1] = '\0';
		StartInd = 1;
	}
	
	if (strcmp(ChatText[StartInd], "bounty", false) == 0)
	{
		new String:CustomBounty[100];
		new String:MenuTitle[100];
		new String:KillsStart[100];
		new String:StartBounty[100];
		new String:KillBonus[100];
		new String:RoundBonus[100];
		new String:ExtBonuses[100];
		new String:Top3Bounties[100];
		new String:NoBounties[100];
		new String:MenuMultyTitle[2000];
		
		Format(CustomBounty, sizeof(CustomBounty), "%t", "custom_bounty");
		Format(MenuTitle, sizeof(MenuTitle), "%t", "bounty_menu_title");
		Format(KillsStart, sizeof(KillsStart), "%t", "bounty_kills_start", MB_KillsStart);
		Format(StartBounty, sizeof(StartBounty), "%t", "bounty_start_bounty", MB_StartBounty);
		Format(KillBonus, sizeof(KillBonus), "%t", "bounty_kill_bonus", MB_KillBonus);
		Format(RoundBonus, sizeof(RoundBonus), "%t", "bounty_round_bonus", MB_RoundBonus);
		Format(ExtBonuses, sizeof(ExtBonuses), "%t", "bounty_ext_bonuses", MB_HeadBonus, "%%", MB_GrenBonus, "%%", MB_KnifeBonus, "%%");
		Format(Top3Bounties, sizeof(Top3Bounties), "%t", "top3_bounties");
		Format(NoBounties, sizeof(NoBounties), "%t", "no_bounties");

		TopPlayerBounty();
		if (strlen(Top3BountiesStr) == 0)
			Top3BountiesStr = NoBounties;
		
		Format(MenuMultyTitle, sizeof(MenuMultyTitle),
		">>%s\n  %s\n  %s\n  %s\n  %s\n  %s\n \n>>%s \n%s \n ",
		MenuTitle,
		KillsStart,
		StartBounty,
		KillBonus,
		RoundBonus,
		ExtBonuses,
		Top3Bounties,
		Top3BountiesStr);
		
		new Handle:menu = CreateMenu(BountyRules);
		SetMenuTitle(menu, MenuMultyTitle);
		AddMenuItem(menu, "CustomBounty", CustomBounty);
		SetMenuExitButton(menu, true);
		DisplayMenu(menu, client, 20);
	}
	return Plugin_Continue;
}

public BountyRules(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		new String:SizeMenuTitle[100];
		new String:HalfMoney[100];
		new String:AllMoney[100];
		new String:HalfMoneyStr[100];
		new String:AllMoneyStr[100];
		
		Format(SizeMenuTitle, sizeof(SizeMenuTitle), "%t", "bounty_size_title");
		Format(HalfMoney, sizeof(HalfMoney), "%t", "bounty_size_half");
		Format(AllMoney, sizeof(AllMoney), "%t", "bounty_size_all");
		
		new ClientCash = GetEntData(param1, PlCash);
		Format(HalfMoneyStr, sizeof(HalfMoneyStr), "%d", (ClientCash/2));
		Format(AllMoneyStr, sizeof(AllMoneyStr), "%d", ClientCash);
		
		new Handle:menu1 = CreateMenu(BountySizeSelect);
		SetMenuTitle(menu1, SizeMenuTitle);
		AddMenuItem(menu1, "500", "500$");
		AddMenuItem(menu1, "1000", "1000$");
		AddMenuItem(menu1, "2000", "2000$");
		AddMenuItem(menu1, "5000", "5000$");
		AddMenuItem(menu1, "10000", "10000$");
		AddMenuItem(menu1, HalfMoneyStr, HalfMoney);
		AddMenuItem(menu1, AllMoneyStr, AllMoney);
		SetMenuExitButton(menu1, true);
		DisplayMenu(menu1, param1, 20);
	}
}

public BountySizeSelect(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		new String:TargetMenuTitle[100];
		new String:info[100];
		new String:playerid[10];
		new String:TargetName[255];

		GetMenuItem(menu, param2, info, sizeof(info));
		
		for (new i=0; i<PlCount; i++)
		{
			if (GetClientOfUserId(players[i]) == param1)
				customs[i] = StringToInt(info);
		}
		
		Format(TargetMenuTitle, sizeof(TargetMenuTitle), "%t", "bounty_target_title", info);

		new Handle:menu2 = CreateMenu(BountyTargetSelect);
		SetMenuTitle(menu2, TargetMenuTitle);
		for (new i=0; i<PlCount; i++)
		{
			new TargetTeam = GetClientTeam(GetClientOfUserId(players[i]));
			new ClientTeam = GetClientTeam(param1);
			if (TargetTeam > 1 && TargetTeam != ClientTeam)
			{
				GetClientName(GetClientOfUserId(players[i]), TargetName, sizeof(TargetName));
				Format(playerid, sizeof(playerid), "%d", i);
				AddMenuItem(menu2, playerid, TargetName);
			}
		}
		SetMenuExitButton(menu2, true);
		DisplayMenu(menu2, param1, 20);
	}
}

public BountyTargetSelect(Handle:menu, MenuAction:action, param1, param2)
{
	if (action == MenuAction_Select)
	{
		new String:info[100];
		new String:CustomerName[255];
		new String:TargetName[255];
		new String:CustomerNameCl[270];
		new String:TargetNameCl[270];
		new String:BountySizeCl[20];
		new PlayerInd, TargetInd;
		
		for (new i=0; i<PlCount; i++)
		{
			if (GetClientOfUserId(players[i]) == param1)
				PlayerInd = i;
		}
		GetMenuItem(menu, param2, info, sizeof(info));
		TargetInd = StringToInt(info);
		
		new ClientCash = GetEntData(param1, PlCash);
		if (customs[PlayerInd] > ClientCash)
		{
			PrintToChat(param1, "\x03%t", "poor_money");
		} else {
			new ClientCashNew = ClientCash - customs[PlayerInd];
			SetEntData(param1, PlCash, ClientCashNew, _, true);
			bounties[TargetInd] = bounties[TargetInd] + customs[PlayerInd];
			

			if (players[TargetInd] != 0)
			{
				SetEntityRenderMode(GetClientOfUserId(players[TargetInd]), RENDER_TRANSCOLOR);
				new TargetTeam = GetClientTeam(GetClientOfUserId(players[TargetInd]));
				if (TargetTeam == 2)
					SetEntityRenderColor(GetClientOfUserId(players[TargetInd]), MB_TRed, MB_TGreen, MB_TBlue, MB_TAlpha);
				if (TargetTeam == 3)
					SetEntityRenderColor(GetClientOfUserId(players[TargetInd]), MB_CTRed, MB_CTGreen, MB_CTBlue, MB_CTAlpha);
				
				GetClientName(param1, CustomerName, sizeof(CustomerName));
				GetClientName(GetClientOfUserId(players[TargetInd]), TargetName, sizeof(TargetName));
				
				if (MB_HelpAdvert)
					CreateTimer(5.0, ShowAdverts);
					
				Format(CustomerNameCl, sizeof(CustomerNameCl), "\x04%s\x03", CustomerName);
				Format(TargetNameCl, sizeof(TargetNameCl), "\x04%s\x03", TargetName);
				Format(BountySizeCl, sizeof(BountySizeCl), "\x04%d$\x03", customs[PlayerInd]);
				PrintToChatAll("\x03%t", "bounty_customed", CustomerNameCl, BountySizeCl, TargetNameCl);
			}
		}
	}
}
